Index: replex/ringbuffer.h
===================================================================
--- replex/ringbuffer.h	(revision 18755)
+++ replex/ringbuffer.h	(working copy)
@@ -2,7 +2,8 @@
  * ringbuffer.h
  *        
  *
- * Copyright (C) 2003 Marcus Metzler <mocm@metzlerbros.de>
+ * Copyright (C) 2003 - 2006
+ *                    Marcus Metzler <mocm@metzlerbros.de>
  *                    Metzler Brothers Systementwicklung GbR
  *
  * This program is free software; you can redistribute it and/or
@@ -40,12 +41,12 @@
 	typedef struct ringbuffer {
 		int read_pos;
 		int write_pos;
-		uint32_t size;
+		int size;
 		uint8_t *buffer;
 	} ringbuffer;
 
 
-#define DBUF_INDEX 10000
+#define DBUF_INDEX 1000
 
 	typedef struct dummy_buffer_s {
 		uint32_t size;
@@ -56,17 +57,13 @@
 
 
 	int  ring_init (ringbuffer *rbuf, int size);
-	int  ring_reinit (ringbuffer *rbuf, int size);
 	void ring_clear(ringbuffer *rbuf);
 	void ring_destroy(ringbuffer *rbuf);
 	int ring_write(ringbuffer *rbuf, uint8_t *data, int count);
 	int ring_read(ringbuffer *rbuf, uint8_t *data, int count);
 	int ring_write_file(ringbuffer *rbuf, int fd, int count);
 	int ring_read_file(ringbuffer *rbuf, int fd, int count);
-	int ring_peek(ringbuffer *rbuf, uint8_t *data, unsigned int count,
-                      uint32_t off);
-	int ring_poke(ringbuffer *rbuf, uint8_t *data, unsigned int count,
-                      uint32_t off);
+	int ring_peek(ringbuffer *rbuf, uint8_t *data, int count, long off);
 	int ring_skip(ringbuffer *rbuf, int count);
 
 	static inline int ring_wpos(ringbuffer *rbuf)
@@ -95,15 +92,15 @@
 		return ring_posdiff(rbuf, rbuf->read_pos,pos);
 	}
 
-	static inline unsigned int ring_free(ringbuffer *rbuf){
+	static inline int ring_free(ringbuffer *rbuf){
 		int free;
-		free = rbuf->read_pos - rbuf->write_pos;
+		free = rbuf->read_pos - rbuf->write_pos-1;
 		if (free <= 0) free += rbuf->size;
-		//Note: free is gauranteed to be >=1 from the above
-		return free - 1;
+		
+		return free;
 	}
 
-	static inline unsigned int ring_avail(ringbuffer *rbuf){
+	static inline int ring_avail(ringbuffer *rbuf){
 		int avail;
 		avail = rbuf->write_pos - rbuf->read_pos;
 		if (avail < 0) avail += rbuf->size;
@@ -121,8 +118,7 @@
 	int dummy_add(dummy_buffer *dbuf, uint64_t time, uint32_t size);
 	void dummy_clear(dummy_buffer *dbuf);
 	int dummy_init(dummy_buffer *dbuf, int s);
-        void dummy_destroy(dummy_buffer *dbuf);
-	void ring_show(ringbuffer *rbuf, unsigned int count, uint32_t off);
+	void ring_show(ringbuffer *rbuf, int count, long off);
 
 #ifdef __cplusplus
 }
Index: replex/element.h
===================================================================
--- replex/element.h	(revision 18755)
+++ replex/element.h	(working copy)
@@ -2,7 +2,8 @@
  * element.h
  *        
  *
- * Copyright (C) 2003 Marcus Metzler <mocm@metzlerbros.de>
+ * Copyright (C) 2003 - 2006
+ *                    Marcus Metzler <mocm@metzlerbros.de>
  *                    Metzler Brothers Systementwicklung GbR
  *
  * This program is free software; you can redistribute it and/or
@@ -51,9 +52,9 @@
 #define PICTURE_DISPLAY_EXTENSION    0x07
 
 #define I_FRAME 0x01
-#define P_FRAME 0x02
-#define B_FRAME 0x03
-#define D_FRAME 0x04
+#define B_FRAME 0x02
+#define P_FRAME 0x03
+#define D_FRAME 0x03
 
 #define OFF_SIZE 4
 #define FIRST_FIELD 0
@@ -74,13 +75,17 @@
 #define PULLDOWN32 1
 #define PULLDOWN23 2
 
+#define PROGRESSIVE 1
+#define ONE_FIELD 2
+#define TWO_FIELD 3
+
 #define CLOCK_MS        27000ULL
 #define CLOCK_PER    27000000000ULL
 #define SEC_PER      (CLOCK_PER/s->frame_rate)
 
 
 enum {
-	NONE=0,AC3, MPEG_AUDIO, LPCM, MAX_TYPES
+	NONE=0,AC3, MPEG_AUDIO, LPCM
 };
 
 typedef struct sequence_s{
@@ -109,32 +114,36 @@
 struct audio_frame_s{
 	int set;
 	int layer;
+	int padding;
+        int sample_rate;
+        int mpg25;
+        int lsf;
 	uint32_t bit_rate;
 	uint32_t frequency;
 	uint32_t mode;
 	uint32_t mode_extension;
 	uint32_t emphasis;
 	uint32_t framesize;
-	uint32_t frametime;
 	uint32_t off;
-	char     language[4];
+	
 } audio_frame_t;
 
 void pts2time(uint64_t pts, uint8_t *buf, int len);
-int find_audio_sync(ringbuffer *rbuf, uint8_t *buf, int off, int type, int le);
-int find_audio_s(uint8_t *rbuf, int off, int type, int le);
-int get_video_info(ringbuffer *rbuf, sequence_t *s, int off, int le);
-int get_audio_info(ringbuffer *rbuf, audio_frame_t *af, int off, int le); 
-int get_ac3_info(ringbuffer *rbuf, audio_frame_t *af, int off, int le);
+int find_audio_sync(ringbuffer *rbuf, uint8_t *buf, long off, int type, int le);
+int find_audio_s(uint8_t *rbuf, long off, int type, int le);
+int get_video_info(ringbuffer *rbuf, sequence_t *s, long off, int le);
+int get_audio_info(ringbuffer *rbuf, audio_frame_t *af, long off, int le, int verb); 
+int get_ac3_info(ringbuffer *rbuf, audio_frame_t *af, long off, int le, int verb);
 uint64_t add_pts_audio(uint64_t pts, audio_frame_t *aframe, uint64_t frames);
 uint64_t next_ptsdts_video(uint64_t *pts, sequence_t *s, uint64_t fcount, uint64_t gcount);
+int  cfix_audio_count(audio_frame_t *aframe, uint64_t origpts, uint64_t pts);
 void fix_audio_count(uint64_t *acount, audio_frame_t *aframe, 
 		     uint64_t origpts, uint64_t pts);
 void fix_video_count(sequence_t *s, uint64_t *frame, uint64_t origpts, 
 		     uint64_t pts, uint64_t origdts, uint64_t dts);
 
 int check_audio_header(ringbuffer *rbuf, audio_frame_t * af, 
-		       int  off, int le, int type);
-int get_video_ext_info(ringbuffer *rbuf, sequence_t *s, int off, int le);
+		       long  off, int le, int type);
+int get_video_ext_info(ringbuffer *rbuf, sequence_t *s, long off, int le);
 
 #endif /*_ELEMENT_H_*/
